;******************************************************************************
;    Filename:        atolto.asm                                              *
;******************************************************************************
;    akkutlt 12 V-os (zsels) lomakkumultorhoz                            *
;******************************************************************************
	list		p=16f1823      ; processzortpus
	list		r=dec
	#include	<p16f1823.inc> ; processzorspecifikus vltozk

; Konfigurci (2 sz)
    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
    __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_HI & _LVP_OFF
    
; Limitek (200xfeszltsg, mert az assembler nem szoroz tizedeseket s a
; program is az egsz szmokat kedveli)
LIM0	EQU	3200/2	; nincs akku (marad nullsban) ha kisebb, mint 8 V
LIM1	EQU	4200/2	; mlytlthet (10,5 V, de nem igaz)
LIM2	EQU	4788/2	; norml tlthet 11,97 V
LIM3	EQU	5640/2	; csepegtethet 14,1 V
LIM4	EQU	5760/2	; megtelt 14,4 V (ne is csepegtessen)
; Ugyanaz nyugalomban
LIM0L	EQU	3200/2	; nincs akku (marad nullsban) ha kisebb, mint 8 V
LIM1L	EQU	4000/2	; mlytlthet 
LIM2L	EQU	4600/2	; norml tlthet 11,5 V 
LIM3L	EQU	5280/2	; csepegtethet	13,2 V 
LIM4L	EQU	5650/2	; megtelt 13,6 V 

; Vltozk
	CBLOCK	0x20	; Nulls lap ltalnos cl rsze
	LOTI2	; hossz idzt fels
	LOTI1	; hossz idzt kzps
	LOTI0	; hossz idzt als
	SHTI	; tervezett rvid idzt
	HUSZAD	; tlt/kist peridus huszadait szmllja
	PFL	; folyamat flag gyjtemny
	BIPCT	; buzzer szmll (lps 0,1 s)
	LEDCT	; LED szmll (lps 0,1 s)
	AVAL	; kimen feszltsg tartomnya
	EAVAL	; ugyanaz az elz mrsbl
	AUXF	; ptflag
	ERRCT	; hibaszmll (hlzatkimaradshoz)
	EAL	; elz kimen feszltsg fels
	EAH	; elz kimen feszltsg als
	RANGE	; segdregiszter (gyjt)
	MAXPH	; visszaessgtl
	ENDC
	CBLOCK 0x70 ; Mindenhonnan lthat terlet
	AH	; kimen feszltsg fels
	AL	; kimen feszltsg als
	BH	; aki a-t mond ...
	BL
	FLAGS	; alapvet flagek
	EFL	; s az elz llapotuk
	PHASE	; az llapotautomata szmszerstewtt llapota
	MCNT	; mrsszmll (mert a mrs 1. lapot hasznl)
	PAB	; port a httr
	PCB	; port b httr
	ACNT	; gyjt szmll
	ENDC
    
; Lbdefincik:
#DEFINE	PIROS	PAB,5	; led      
#DEFINE	ZOLD	PAB,4	; led 
#DEFINE	STPG	PORTA,3	; gomb (start/stop, ltez) (scan 100 ms) 
#DEFINE	STAG	PORTA,2	; gomb (start, opcionlis) (nem l)
#DEFINE	TOLT	PCB,5	; tranz  
#DEFINE	CSEPP	PCB,4	; tranz  
#DEFINE	KISUT	PCB,3	; tranz 
#DEFINE	BUZZ	PCB,2	; buzzer

#DEFINE ITFLAG	FLAGS,0	; 5 ms-onknt
#DEFINE VIZSG	FLAGS,1	; 20 db 5 ms-onknt egyszer (a 17. temben)
#DEFINE	DDT	FLAGS,2	; du/dt vagy idtllps esemny flag
#DEFINE	VALT	FLAGS,3	; kimenfeszltsg tartomnyhatrt lpett flag
#DEFINE	GV	FLAGS,4	; gombvltozs (j gombnyoms) trtnt
#DEFINE	BIMP	FLAGS,5	; kerek 20 ms-onknt
#DEFINE LIMP	FLAGS,6	; kerek 20 ms-onknt
#DEFINE	NYOM	FLAGS,7	; gomb nyomva (2 egyforma rnzssel)
#DEFINE	MELY	AUXF,0	; segdflag dU/dt vizsglathoz
#define	most	auxf,1	
#DEFINE GOMB	STPG 	; stpg mostantl inkbb egyszeren gomb
#DEFINE	AGO	ADCON0,1 ; az adcon go/done bitje	

; MS BITEK
#DEFINE	PIR	PFL,7	; led krs
#DEFINE	ZOL	PFL,6	; led krs
#DEFINE GYORS	PFL,5	; gyors villogs krs
#DEFINE	LASSU	PFL,4	; lass villogs krs
#DEFINE	MEGY	PFL,3	; J EZ ITT
#DEFINE	ROVID	PFL,2	; rvid ftty krs
#DEFINE	HOSSZU	PFL,1	; hossz ftty krs
#DEFINE	BIPREQ	PFL,0	; ftty krs  

#INCLUDE <PRLX.INC>		
;------------------------------------------------------------------------------
; RESET VECTOR
;------------------------------------------------------------------------------
	ORG     0x0000            ; processor reset vector
	PAGESEL START
	GOTO    START
	
; Megszakts: 4 flaget kezel: bemenfesz, kimenfesz + gomb, LED, buzzer
; Frekvencia 200 ill. 10 Hz
	ORG	4
	BANKSEL	PORTA
	BCF	PIR1,TMR2IF
	BSF	ITFLAG
	INCF	HUSZAD,F	; akkor is kell mrni, amikor ll
	CJNEL	HUSZAD,17,ITSK1	; (meg a gombot is figyelni kell)
	BSF	VIZSG		; ezrt vizsg nem lehet feltteles
	RETFIE
ITSK1
	CJNEL	HUSZAD,18,ITSK2
	BSF	BIMP
	BSF	LIMP
	RETFIE
ITSK2
	CSNEL	HUSZAD,10
	CALL	ACT
	CJNEL	HUSZAD,20,SKIT
	CALL	ACT
	CLRF	HUSZAD		; zrja a hurkot
	JNB	MEGY,SKIT	; hossz id csak amikor tlt
	INCF	LOTI0,F
	JNZ	SKIT
	INCF	LOTI1,F
	JNZ	SKIT
	INCF	LOTI2,F
	SNB	LOTI2,2		; kb. 14 s fl ra, binrisan kerektve
	BSF	DDT		; ez az 5. flag, a tl hossz id
SKIT
	RETFIE

;------------------------------------------------------------------------------
; Fprogram, 500 kHz bels oszcilltor
;------------------------------------------------------------------------------
; Fzistmenetek ugrtblja
TODO
	GOTO	SET0	; alapllapot
	GOTO	SET1	; ll, mly, indthat, dU/dt eljegyezve
	GOTO	SET2	; ll, tlag lemerlt,indthat
	GOTO	SET3	; ll, feltlttt, csepptlts indthat
	GOTO	SET4	; ll, megtelt, nem indthat
	GOTO	SET5	; nincs ilyen sorszm llapot
	GOTO	SET6	; nincs
	GOTO	SET7	; nincs
	GOTO	SET8	; tlts kzben eltnt az akku, nullsss vlik
	GOTO	SET9	; tlt mlybl, dU/dt figyelssel
	GOTO	SET10	; tlt simn
	GOTO	SET11	; csepptlt
	GOTO	SET12	; cseppet sem tlt, de visszaeshet 11-re
	GOTO	SET13	; nincs
	GOTO	SET14	; nincs
	GOTO	SET15	; logikailag kilg: dU/dt stop, gombra 0-ra megy
; Fprogram valdi kezdete
START
	BANKSEL	ANSELA
	MOVLW	3		; RA.0,1 analg bemenet
	MOVWF	ANSELA
	CLRF	ANSELC		; c tiszta digitlis
	BANKSEL	PORTA
	MOVLW	0x0C		; a felhzknl 1, mshol 0 
	MOVWF	PORTA
	MOVWF	PAB
	MOVLW	0X0		; minden lelltva 
	MOVWF	PORTC
	MOVWF	PCB
	CLRF	PIR1
	BANKSEL	WPUA
	MOVL	WPUA,0X0C	; gombokhoz bels felhzk
	CLRF	WPUC
	BANKSEL	TRISA
	MOVLW	0x8		; bels felhzk hasznlhatk
	MOVWF	OPTION_REG
	BSF	PIE1,TMR2IE	; az egyetlen megszakts ez lesz
	MOVLW	0X0F		; als nibble bemenet 
	MOVWF	TRISA
	CLRF	TRISC		; a teljes C port kimenet
	BANKSEL	FVRCON
	MOVLW	0X82		; 2,048 V bels A/D referencia
	MOVWF	FVRCON		; referencia belltsa (ANALG)
	NOP
	BANKSEL	PIR1
	CLRF	PIR1
	MOVLW	124		; timer2 peridus (500K/4/125/5=200HZ)
	MOVWF	PR2
	MOVLW	0X20		; Nem indul mg,de: 
	MOVWF	T2CON		; eloszt=1, utoszt=5, freki=200 Hz
	BANKSEL	ADCON0
	MOVL	ADCON1,0X83	; jobbra tmrtett, fosc/2	
	BANKSEL	PORTA
	CLRF	PHASE		; nullzsok
	CLRF	LOTI2
	CLRF	LOTI1
	CLRF	LOTI0
	CLRF	FLAGS
	CLRF	EFL
	CLRF	AUXF
	CLRF	ERRCT
	MOVL	EAVAL,6		; s rgtn klnbz, mert ilyen nincs!
	CLRF	PFL
	clrf	acnt
	clrf	range
	
	BANKSEL	T2CON
	BSF	T2CON,TMR2ON	; Itt indul az ra
	BSF	INTCON,PEIE
	BSF	INTCON,GIE
	CLRF	HUSZAD
	CLRF	MAXPH
	BSF	PIROS
	BSF	LASSU
;	CALL	ACT		; lass piros az alapllsa
	
MAIN				; ide jn vissza a teljes fciklus, ami
				; feltteles hvsok sorozata
	SNB	ITFLAG
	CALL	UBE		; KISZLL (ELALSZIK), ha elfogy a fesz
	SNB	VIZSG	
	CALL	UKI		; tartomny s gomb rtkelse
	SNB	MELY
	CALL	DUDT		; dU/dt lelvs (ha kell)
	MOVF	FLAGS,W
	ANDLW	28
	SZ
	CALL	ATMEN		; tmenetkezels (ha van mit)
	SNB	LIMP
	CALL	LTSK		; LED kezels
	SNB	BIMP		
	CALL	BTSK		; buzzer kezels
	GOTO	MAIN		; zrja a hurkot

; tmeneti fggvny. Minden tovbbi a tsk.inc fjlban.
ATMEN
	JB	VALT,TEDD1	; ha a feszltsg vltozott
	JB	GV,TEDD2	; ha a gomb vltozott
	JB	DDT,TEDD3	; ha a DDT llt fel
	RETURN			; ha (mr) nincs vltozs, szabadul
TEDD1
	BCF	VALT
	SNB	PHASE,4		; ha phase.4=1, a feszltsg nem szmt,
	GOTO	ATMEN		; visszamegy megnzni a msik kettt
	GOTO	SKT1
TEDD2
	BCF	GV
	BCF	PHASE,4
	MOVLW	8
	XORWF	PFL,F		; GY LESZ TOGGLE
	CLRF	LOTI0
	CLRF	LOTI1
	CLRF	LOTI2
SKT1
	MOVF	PFL,W
	ANDLW	8
	ADDWF	AVAL,W
	ANDLW	15
	MOVWF	PHASE
	CJBL	PHASE,9,SKT2
	MOVF	PHASE,W
	SUBWF	MAXPH,W	; w=maxph-w, carry ha maxph>w
	MOVF	PHASE,W
	SC
	MOVWF	MAXPH	; Ha nincs carry, akkor j maxph szletett
	MOVF	MAXPH,W
	SNC
	MOVWF	PHASE	; ha viszont nem, akor is phase=maxph
SKT2
	MOVF	PHASE,W
	ADDLW	TODO
	CALLW	
	GOTO	ATMEN
TEDD3
	GOTO	SET15
	
SET0	; Nincs akku: sok gyors ftty, lass piros villog, minden ki
	BCF	KISUT
	BCF	TOLT
	BCF	CSEPP
	BCF	MELY
	CLRF	MAXPH
	CLRF	BIPCT
	BSF	ROVID
	BCF	HOSSZU
	BSF	LASSU
	BCF	GYORS
	BSF	PIR
	BCF	ZOL
	BSF	BIPREQ
	RETURN
SET1	; mly akku: nincs ftty (?), gyors piros, minden ki	
	BCF	KISUT
	BCF	TOLT
	BCF	CSEPP
	BCF	ROVID
	BCF	HOSSZU
	BCF	LASSU
	BSF	GYORS
	BSF	PIR
	BCF	ZOL
	BCF	BIPREQ
	bsf	mely
	bcf	buzz
	RETURN
SET2	; j akku: nincs hang, gyors zld villog
	BCF	KISUT
	BCF	TOLT
	BCF	CSEPP
	BCF	ROVID
	BCF	HOSSZU
	BCF	LASSU
	BSF	GYORS
	BCF	PIR
	BSF	ZOL
	BCF	BIPREQ
	BCF	BUZZ
	RETURN
SET3	; feltlttt akku: nincs hang, folyamatos zld, minden ki
	BCF	KISUT
	BCF	TOLT
	BCF	CSEPP
	BCF	ROVID
	BCF	HOSSZU
	BCF	LASSU
	BCF	GYORS
	BCF	PIR
	BSF	ZOL
	BCF	BIPREQ
	BCF	BUZZ
	RETURN
SET4	; totl tele akku:  is folyamatos zld, minden ki
	BCF	KISUT
	BCF	TOLT
	BCF	CSEPP
	BCF	ROVID
	BCF	HOSSZU
	BCF	LASSU
	BCF	GYORS
	BCF	PIR
	BSF	ZOL
	BCF	BIPREQ
	BCF	BUZZ
	RETURN
SET5
	GOTO	SET4
SET6
	RETURN
SET7	
	RETURN
SET8	; menet kzben eltnt az akku
	BCF	MEGY	; egy sorral feljebb az llapottbln!
	BCF	BUZZ	; egyelre kuss
	GOTO	SET0	; majd  fttyg (reset llapot)
; gomb utn:
SET9	; mlybl tlt: gyors srga villog, sok kis ftty, norml tlts
	BCF	KISUT
	BCF	CSEPP
	CLRF	BIPCT
	BSF	ROVID
	BCF	HOSSZU
	BCF	LASSU
	BSF	GYORS
	BSF	PIR
	BSF	ZOL
	BSF	BIPREQ
	RETURN
SET10	; norml tlt: nincs ftty, lass srga villog, norml tlts
	BCF	KISUT
	BCF	CSEPP
	BCF	ROVID
	BCF	HOSSZU
	BSF	LASSU
	BCF	GYORS
	BSF	PIR
	BSF	ZOL
	BCF	BIPREQ
	BCF	BUZZ
	RETURN
SET11	; csepptlts: nincs hang, lland zld
	BCF	KISUT
	BCF	TOLT
	BCF	ROVID
	BCF	HOSSZU
	BCF	LASSU
	BCF	GYORS
	BCF	PIR
	BSF	ZOL
	BCF	BIPREQ
	RETURN
SET12	; tltlts: hossz hang, folyamatos zld
	BCF	KISUT
	BCF	TOLT
	BCF	CSEPP
	MOVL	BIPCT,12
	BCF	ROVID
	BSF	HOSSZU
	BCF	LASSU
	BCF	GYORS
	BCF	PIR
	BSF	ZOL
	BSF	BIPREQ
	RETURN
SET13
	GOTO	SET12
SET14
	RETURN
SET15		; A ddt stop van 15-s llapotnak lczva
	BSF	PHASE,4
	BCF	KISUT
	BCF	TOLT
	BCF	CSEPP
	CLRF	BIPCT
	BSF	ROVID
	BCF	HOSSZU
	BCF	LASSU
	BCF	GYORS
	BSF	PIR
	BCF	ZOL
	BSF	BIPREQ
	RETURN	

#INCLUDE	<TSK.INC>		
    END